﻿window.global = {
    appName: "Swap It",
    serviceURL: "http://213.34.206.43/Swap.Service/Handler.svc/",
    prevPage: "",
    ownerId: "",
    TranStatusAccepted: 3,
    TranStatusPending: 1,
    TranStatusCompleted: 5,
    isSpecial: false,
    appType: 1,
    senderId: '1072545718837'
};

var swapItems = [];
var pendingSwapViewArr;
var pendingSwapVavIndex = 0;

//Push notifications public paramtter 
var pushNotification;

$(document).ready(function () {

    //#region Initializtion

    //allow acros domains transfere  without using jsonp
    $.support.cors = true;
    $.mobile.allowCrossDomainPages = true;

    // attatch fast click to remove delay of message appearing
    // $(function () { FastClick.attach(document.body); });

    document.addEventListener('deviceready', function () {
        // Set all pages with class="page-content" to be at least contentHeight
        var viewPortHeight = $(window).height();
        var headerHeight = $('div[data-role="header"]').height();
        var footerHeight = $('div[data-role="footer"]').height();
        var contentHeight = viewPortHeight - headerHeight - footerHeight;
        $('div[class="page-content"]').css({ 'min-height': contentHeight + 'px' });

        // native alert
        if (navigator.notification) {
            window.alert = function (message) {
                navigator.notification.alert(
                    message,
                    null,
                    window.global.appName,
                    "OK"
                    );
            };
        }
    }, true);

    document.addEventListener("backbutton", function (e) {
        if ($.mobile.activePage.is('#main') || $.mobile.activePage.is('#home')) {

            if (confirm(res.confirmClose)) {
                e.preventDefault();
                app.exit();
            }
        }
        else {
            app.onBackButton(e);
        }
    }, false);

    // set common ajax properties
    $(document).ajaxSend(function () {
        $.mobile.loading('show');
    });

    $(document).ajaxComplete(function () {
        $.mobile.loading('hide');
    });

    // to slow the senstivity of touch and swipe
    $(document).bind("mobileinit", function () {
        $.event.special.tap.tapholdThreshold = 1000,
        $.event.special.swipe.durationThreshold = 900;
        $.mobile.defaultPageTransition = "none";
        $.mobile.defaultDialogTransition = 'none';
    });

    //#endregion

    //#region Global

    $(window).hashchange(app.onLoadPage);

    // add side menu
    $(".dvMnu").each(function () {
        if (localStorage.getItem("Swap_lang") == "en" || localStorage.getItem("Swap_lang") == null) {
            $(this).html(Handlebars.compile($("#tmpl_EnSidePanel").html()));
        }
        else {
            $(this).html(Handlebars.compile($("#tmpl_ArSidePanel").html()));
        }
        $(this).trigger('create');

        $(".cls_Bar").click(function () {
            $.mobile.activePage.find('.cls_Panel').panel("open");
        });

    });

    $("[name='btOwnerItems']").click(function () {
        $("#hdnOwnerSrc").val($.mobile.activePage.attr("id"));
        $.mobile.changePage("#ownerItems", { changeHash: true });
    });

    $("[name='btnSwap']").click(function () {
        if (localStorage.getItem("Swap_UserId") !== null) {
            swap.goSwap();
        }
        else {
            window.global.prevPage = $.mobile.activePage.attr("id");
            $.mobile.changePage("#myAccount", { changeHash: true });
        }
    });

    $("[name='mnuExit']").click(function () {
        if (confirm(res.exitMsg)) {
            app.exit();
        }
    });

    //swipe to open panel
    if (localStorage.getItem("Swap_lang") == "en" || localStorage.getItem("Swap_lang") == null) {
        $("body").swiperight(function () {
            $.mobile.activePage.find('.cls_Panel').panel("open");
            loadPanel();
        });
    }
    else {
        $("body").swipeleft(function () {
            $.mobile.activePage.find('.cls_Panel').panel("open");
            loadPanel();
        });
    }

    $("body").on('movestart', function (e) {
        // If the movestart is heading off in an upwards or downwards
        // direction, prevent it so that the browser scrolls normally.
        if ((e.distX > e.distY && e.distX < -e.distY) ||
            (e.distX < e.distY && e.distX > -e.distY)) {
            e.preventDefault();
        }
    });

    //#endregion

    //#region Main

    $("#btnEnterEn").click(function () {
        localStorage.setItem("Swap_lang", "en");
        $.mobile.changePage("#temp", { changeHash: true });
        location.reload();
    });

    $("#btnEnterAr").click(function () {
        localStorage.setItem("Swap_lang", "ar");
        $.mobile.changePage("#temp", { changeHash: true });
        location.reload();
    });

    $(document).delegate("#temp", "pageshow", function (event) {

        $.mobile.loading('show');
        setTimeout(function () {
            if ($.mobile.activePage.attr("id") == "temp") {
                $.mobile.changePage("#home", { changeHash: true, transition: "none" });
                $.mobile.loading('hide');

            }
        }, 1)
    });

    //#endregion

    //#region Home

    $("#btnSrchHome").click(function () {
        var str = $("#txtHomeSrch").val();
        if (str !== "") {
            home.search(str);
        }
        else {
            home.load();
        }
    });


    //#endregion

    //#region myAccount

    $("#btnLogin").click(function () {
        if (myAccount.validateLogin()) {
            myAccount.login($("#txtLoginMail").val(), $("#txtLoginPassword").val());
        }
    });

    $("#btnLogout").click(function () {
        localStorage.removeItem("Swap_UserId");
        $('input[name^="hdn"]').val("");
        $.mobile.changePage("#home", { changeHash: true });
    });

    $(document).on("pagehide", "#myAccount", function () {
        window.global.prevPage = "";
    });

    //#endregion

    //#region register

    $("#btnSubmitRegister").click(function () {
        if (register.validate()) {
            if (localStorage.getItem("Swap_UserId") === null) {
                register.register();
            }
            else {
                register.update();
            }
        }
    });

    $(document).on("pagehide", "#register", function () {
        register.clear();
    });

    //#endregion

    //#region reset password

    $("#btnResetPwd").click(function () {
        resetPwd.reset();
    });

    //#endregion

    //#region contact us

    $("#btnContactSend").click(function () {
        if (contactUs.validate()) {
            contactUs.send();
        }
    });

    //#endregion

    //#region add Item

    $("[name='btnCancelCamera']").click(function () {
        $(".ui-dialog").dialog("close");
    });

    $("#btnCamera").click(function () {

        navigator.camera.getPicture(
           camera.success,
           camera.fail,
            { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, encodingType: Camera.EncodingType.JPEG, sourceType: Camera.PictureSourceType.CAMERA, allowEdit: true });
    });

    $("#btnGallery").click(function () {
        navigator.camera.getPicture(
            camera.success,
            camera.fail,
             { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY, encodingType: Camera.EncodingType.JPEG, allowEdit: true });
    });

    $("#btnSaveItem").click(function () {
        window.global.isSpecial = false;
        if (addItem.validate()) {
            camera.upload(false, "main");
        }
    });

    $("#ddlSection").change(function () {
        $("#hdnSelectedSection").val($("#ddlSection").val());
    });

    //#endregion

    //#region user items

    $("#btnDeleteItem").click(function () {
        userItems.deleteItem();
    });

    $(document).on("pagebeforehide", "#userItems", function () {
        $("#dvUserItems").html("");
    });

    //#endregion

    //#region user Swap

    $(document).on("pagebeforehide", "#userSwap", function () {
        $("#dvUserSwap").html("");
    });

    $("#btnSaveSwap").click(function () {
        swap.doSwap();
    });

    $("#btnCancelSwapDlg").click(function () {
        $(".ui-dialog").dialog("close");
    });

    //#endregion

    //#region owner items

    $(document).on("pagebeforehide", "#ownerItems", function () {
        $("#dvOwnerItems").html("");
    });

    //#endregion

    //#region search

    $("#btnSearch").click(function () {
        search.search();
    });

    //#endregion

    //#region pending swap

    $("#btnNextItem").click(function () {
        if (pendingSwapVavIndex === pendingSwapViewArr.length) {
            return;
        }
        else {
            pendingSwapVavIndex++;
            $("#imgPendingSwap").attr("src", pendingSwapViewArr[pendingSwapVavIndex].ImageUrl);
            $("#dvPendingSwapViewDesc").text(pendingSwapViewArr[pendingSwapVavIndex].Description);
        }
    });

    $("#btnPrevtItem").click(function () {
        if (pendingSwapVavIndex === 0) {
            return;
        }
        else {
            pendingSwapVavIndex--;
            $("#imgPendingSwap").attr("src", pendingSwapViewArr[pendingSwapVavIndex].ImageUrl);
            $("#dvPendingSwapViewDesc").text(pendingSwapViewArr[pendingSwapVavIndex].Description);
        }
    });

    $(document).on("pagebeforehide", "#pendingSwapViwe", function () {
        pendingSwapViewArr = [];
        pendingSwapVavIndex = 0;
        $("#hdnTransactionId").val("");
        $("#hdnSwapOwnerId").val("");
    });

    $("#btnSwapCancel").click(function () {
        pendingSwap.cancel($("#hdnTransactionId").val());
        $.mobile.changePage("#pendingSwap", { changeHash: true });
    });

    $("#btnSwapAccept").click(function () {
        pendingSwap.accept($("#hdnTransactionId").val());
        $.mobile.changePage("#pendingSwap", { changeHash: true });
    });

    $("#btnSwapReject").click(function () {
        pendingSwap.reject($("#hdnTransactionId").val());
        $.mobile.changePage("#pendingSwap", { changeHash: true });
    });

    $("#btnSwapComplete").click(function () {
        pendingSwap.complete();
    });

    $("#btnSwapCall").click(function () {
        pendingSwap.call($("#hdnTransactionId").val());
        $.mobile.changePage("#pendingSwap", { changeHash: true });
    });

    $("#btnCancelSwap").click(function () {
        pendingSwap.Reset();
    });

    //#endregion

    //#region add special

    $("#btnAddSpecial").click(function () {
        window.global.isSpecial = true;
        if (addItem.validate()) {
            camera.upload(false, "main");
        }
    });

    $("#btnCamera1").click(function () {
        navigator.camera.getPicture(
          camera.success1,
          camera.fail,
           { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, encodingType: Camera.EncodingType.JPEG, sourceType: Camera.PictureSourceType.CAMERA, allowEdit: true });
    });

    $("#btnCamera2").click(function () {
        navigator.camera.getPicture(
          camera.success2,
          camera.fail,
           { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, encodingType: Camera.EncodingType.JPEG, sourceType: Camera.PictureSourceType.CAMERA, allowEdit: true });
    });

    $("#btnCamera3").click(function () {
        navigator.camera.getPicture(
          camera.success3,
          camera.fail,
           { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, encodingType: Camera.EncodingType.JPEG, sourceType: Camera.PictureSourceType.CAMERA, allowEdit: true });
    });

    $("#btnGallery1").click(function () {
        navigator.camera.getPicture(
            camera.success1,
            camera.fail,
             { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY, encodingType: Camera.EncodingType.JPEG, allowEdit: true });
    });

    $("#btnGallery2").click(function () {
        navigator.camera.getPicture(
            camera.success2,
            camera.fail,
             { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY, encodingType: Camera.EncodingType.JPEG, allowEdit: true });
    });

    $("#btnGallery3").click(function () {
        navigator.camera.getPicture(
            camera.success3,
            camera.fail,
             { quality: 50, destinationType: navigator.camera.DestinationType.FILE_URI, sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY, encodingType: Camera.EncodingType.JPEG, allowEdit: true });
    });

    $("#btnSaveSpecial").click(function () {
        $.mobile.loading('show');

        $img1 = $("#imgPreview1");
        $img2 = $("#imgPreview2");
        $img3 = $("#imgPreview3");

        if (!($img1.attr("src").indexOf("add-photo") > -1)) {
            camera.upload(true, "special1");
        }

        if (!($img2.attr("src").indexOf("add-photo") > -1)) {
            camera.upload(true, "special2");
        }

        if (!($img3.attr("src").indexOf("add-photo") > -1)) {
            camera.upload(true, "special3");
        }

        $.mobile.loading('hide');

        addItem.clear();
        $img1.removeAttr("src");
        $img2.removeAttr("src");
        $img3.removeAttr("src");
        $.mobile.changePage("#userItems", { changeHash: true });
    });

    //#endregion

    //#region setting

    $("#chkNotification").change(function () {
        setting.change();
    });

    //#endregion

    var height = parseInt($(window).height()) - parseInt(40);
    $(".ui-panel-inner").css("height", height);

});


var app = {

    onBackButton: function () {
        var current = $.mobile.activePage.attr("id");
        switch (current) {

            case "sections":
                $.mobile.changePage("#home", { changeHash: true });
                break;

            case "items":
                $("#dvItems").html("");
                $.mobile.changePage("#sections", { changeHash: true });
                break;

            case "itemView":
                $.mobile.changePage("#items", { changeHash: true });
                break;

            case "ownerItems":
                if ($("#hdnOwnerSrc").val() === "homeItemView") {
                    items.open($("#hdnItemId").val(), "home");
                }
                else if ($("#hdnOwnerSrc").val() === "itemView") {
                    items.open($("#hdnItemId").val(), "items");
                }
                else if ($("#hdnOwnerSrc").val() === "searchItemView") {
                    items.open($("#hdnItemId").val(), "search");
                }
                else if ($("#hdnOwnerSrc").val() === "favouriteItemView") {
                    items.open($("#hdnItemId").val(), "favourite");
                }
                break;

            case "ownerItemView":
                $.mobile.changePage("#ownerItems", { changeHash: true });
                break;

            case "myAccount":
                if (window.global.prevPage === "itemView") {
                    items.open($("#hdnItemId").val(), "items");
                }
                else if (window.global.prevPage === "homeItemView") {
                    items.open($("#hdnItemId").val(), "home");
                }
                else if (window.global.prevPage === "ownerItemView") {
                    items.open($("#hdnItemId").val(), "owner");
                }
                else {
                    $.mobile.changePage("#home", { changeHash: true });
                }
                break;

            case "resetPassword":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "userItems":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "userItemView":
                $.mobile.changePage("#userItems", { changeHash: true });
                break;

            case "homeItemView":
                $.mobile.changePage("#home", { changeHash: true });
                break;

            case "addItem":
                $.mobile.changePage("#userItems", { changeHash: true });
                break;

            case "contactUs":
                $.mobile.changePage("#setting", { changeHash: true });
                break;

            case "userSwap":
                history.go(-1);
                break;

            case "search":
                $.mobile.changePage("#home", { changeHash: true });
                break;

            case "searchItems":
                $.mobile.changePage("#search", { changeHash: true });
                break;

            case "searchItemView":
                $.mobile.changePage("#searchItems", { changeHash: true });
                break;

            case "register":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "pendingSwap":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "pendingSwapViwe":
                // history.go(-1);
                $.mobile.changePage("#pendingSwap", { changeHash: true });
                break;

            case "completedSwap":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "favourite":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "favouriteItemView":
                $.mobile.changePage("#favourite", { changeHash: true });
                break;

            case "addSpecial":
                $.mobile.changePage("#addItem", { changeHash: true });
                break;

            case "setting":
                $.mobile.changePage("#myAccount", { changeHash: true });
                break;

            case "aboutUs":
                $.mobile.changePage("#setting", { changeHash: true });
                break;

            case "specialAdvantage":
                $.mobile.changePage("#setting", { changeHash: true });
                break;

            case "ads":
                $.mobile.changePage("#home", { changeHash: true });
                break;

            case "notifications":
                $.mobile.changePage("#home", { changeHash: true });
                break;

            case "notificationView":
                $.mobile.changePage("#notifications", { changeHash: true });
                break;

        }
    },

    onLoadPage: function () {
        var hash = location.hash;
        switch (hash) {

            case "#home":
                home.localize();
                home.load();
                break;

            case "#sections":
                section.localize();
                section.load();
                break;

            case "#myAccount":
                myAccount.localize();
                myAccount.load();
                break;

            case "#register":
                register.load();
                register.localize();
                break;

            case "#resetPassword":
                resetPwd.localize();
                break;

            case "#userItems":
                userItems.localize();
                userItems.load(false);
                break;

            case "#ownerItems":
                ownerItems.localize();
                ownerItems.load();
                break;

            case "#addItem":
                addItem.localize();
                addItem.load();
                break;

            case "#contactUs":
                contactUs.localize();
                break;

            case "#message":
                message.load();
                break;

            case "#userSwap":
                swap.localize();
                userItems.load(true);
                break;

            case "#search":
                search.localize();
                search.load();
                break;

            case "#pendingSwap":
                pendingSwap.load();
                break;

            case "#pendingSwapViwe":
                pendingSwap.swapViewLocalize();
                break;

            case "#completedSwap":
                completedSwap.load();
                break;

            case "#homeItemView":
                home.itemViewLoad();
                break;

            case "#itemView":
                itemView.load();
                break;

            case "#ownerItemView":
                ownerItems.itemViewLoad();
                break;

            case "#searchItemView":
                search.itemViewLoad();
                break;

            case "#favourite":
                favourite.load();
                break;

            case "#favouriteItemView":
                favourite.itemViewLoad();
                break;

            case "#addSpecial":
                addSpecial.localize();
                break;

            case "#setting":
                setting.localize();
                setting.load();
                break;

            case "#aboutUs":
                aboutUs.localize();
                break;

            case "#specialAdvantage":
                specialAdvantage.localize();
                break;

            case "#ads":
                ads.load();
                break;

            case "#notifications":
                notifications.load();
                break;

        }
    },

    exit: function () {
        navigator.app.exitApp();
    }

}

var home = {

    localize: function () {
        $("#txtHomeSrch").attr("placeholder", res.srchPlaceHolder);
        $("#lblHomeHeader").text(res.homeHeader);
    },

    load: function () {

        // alert($($(".ui-panel")[0]).height());
        //alert($(window).height());

        var userId = 0;
        if (localStorage.getItem("Swap_UserId") !== null) {
            userId = localStorage.getItem("Swap_UserId");
        }
        $.ajax({
            type: "GET",
            dataType: "json",
            // remeber to uncomment special image in the template [tmpl_HomeItems]
            //url: window.global.serviceURL + "soap/GetSpecialItems?userId=" + userId,
            url: window.global.serviceURL + "soap/GetLatestItems?userId=" + userId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $("#dvHomeContent").html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                type: "home"
                            });
                        }

                        $("#dvHomeContent").html("");
                        var template = Handlebars.compile($("#tmpl_HomeItems").html());
                        $("#dvHomeContent").html(template(jsonItems));
                        $("#dvHomeContent").trigger('create');
                    }
                    else {
                        $("#dvHomeContent").html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    search: function (string) {
        $dvHomeContent = $("#dvHomeContent");
        var userId = 0;
        if (localStorage.getItem("Swap_UserId") !== null) {
            userId = localStorage.getItem("Swap_UserId");
        }
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/SearchItems?strSearch=" + string + "&sectionId=0&onlySpecial=true&userId=" + userId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvHomeContent.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                type: "home"
                            });
                        }

                        $dvHomeContent.html("");
                        var template = Handlebars.compile($("#tmpl_HomeItems").html());
                        $dvHomeContent.html(template(jsonItems));
                        $dvHomeContent.trigger('create');
                    }
                    else {
                        $dvHomeContent.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    openItem: function (itemId) {

        $("#btnHomeSwap").text(res.swap);
        $("#btnHomeOwnerItems").text(res.ownerItems);

        // prepare imgs container
        $reslide = $("#ulHomeItemView");
        $reslide.html("");
        $reslide.html("<li><img id='imgHomeItemView' src=''/></li>")

        $image = $("#imgHomeItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    $.mobile.changePage("#home", { changeHash: true });
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblHomeItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvHomeItemViewDec").text(jsonArray[0].Description);
                    window.global.ownerId = jsonArray[0].OwnerId;
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {
                favourite.isFavourite(itemId, "btnHomeAddFavourite");

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    itemViewLoad: function () {
        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvHomwItemViewGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvHomwItemViewGrp").addClass("ui-btn-left");
        }
    }

}

var section = {

    localize: function () {
        $("#lblSectionsHeader").text(res.sectionsHeader);
    },

    load: function () {

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetSections?lang=" + localStorage.getItem("Swap_lang"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $("#dvSections").html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonSection = { sections: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonSection.sections.push({
                                SectionId: jsonArray[i].SectionId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                SectionName: jsonArray[i].SectionName
                            });
                        }

                        $("#dvSections").html("");
                        var template = Handlebars.compile($("#tmpl_sections").html());
                        $("#dvSections").html(template(jsonSection));
                        $("#dvSections").trigger('create');
                    }
                    else {
                        $("#dvSections").html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    open: function (sectionId, sectionName) {
        items.load(sectionId, sectionName);
        $.mobile.changePage("#items", { changeHash: true });
    }
}

var items = {

    load: function (sectionId, sectionName) {
        $("#lblItemsHeader").text(sectionName);

        var userId = 0;
        if (localStorage.getItem("Swap_UserId") !== null) {
            userId = localStorage.getItem("Swap_UserId");
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemsBySection?sectionId=" + sectionId + "&userId=" + userId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $("#dvItems").html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                IsSpecial: jsonArray[i].IsSpecial,
                                type: "items"
                            });
                        }

                        $("#dvItems").html("");
                        var template = Handlebars.compile($("#tmpl_items").html());
                        $("#dvItems").html(template(jsonItems));
                        $("#dvItems").trigger('create');
                    }
                    else {
                        $("#dvItems").html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    open: function (itemId, type) {

        if (type === "user") {
            $.mobile.changePage("#userItemView", { changeHash: true });
            userItems.openItem(itemId);
        }
        else if (type === "items") {
            $.mobile.changePage("#itemView", { changeHash: true });
            itemView.openItem(itemId);
        }
        else if (type == "home") {
            $.mobile.changePage("#homeItemView", { changeHash: true });
            home.openItem(itemId);
        }
        else if (type === "owner") {
            $.mobile.changePage("#ownerItemView", { changeHash: true });
            ownerItems.openItem(itemId);
        }
        else if (type === "swap") {
            swap.select(itemId);
        }
        else if (type === "search") {
            $.mobile.changePage("#searchItemView", { changeHash: true });
            search.openItem(itemId);
        }
        else if (type === "favourite") {
            $.mobile.changePage("#favouriteItemView", { changeHash: true });
            favourite.openItem(itemId);
        }
    },

    getMorePics: function (itemid, $reslides) {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemPictures?itemId=" + itemid,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {

                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {

                        var pics = "";
                        for (i = 0; i < jsonArray.length; i++) {
                            pics += "<li><img src=" + jsonArray[i].ItemPic + " /></li>";
                        }


                        //  $reslides = $(".rslides");
                        $reslides.append(pics);

                        $reslides.responsiveSlides({
                            auto: false,
                            pager: false,
                            nav: true,
                            speed: 500,
                            namespace: "callbacks",
                        });

                    }
                    else {
                        $(".callbacks_nav").hide();
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

}

var itemView = {

    load: function () {
        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvItemViewGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvItemViewGrp").addClass("ui-btn-left");
        }
    },

    openItem: function (itemId) {

        $("#btnItemSwap").text(res.swap);
        $("#btnItemOwnerItems").text(res.ownerItems);

        // prepare imgs container
        $reslide = $("#ulItemView");
        $reslide.html("");
        $reslide.html("<li><img id='imgItemView' src='' /></li>")

        $image = $("#imgItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    $.mobile.changePage("#items", { changeHash: true });
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvItemViewDec").text(jsonArray[0].Description);
                    window.global.ownerId = jsonArray[0].OwnerId;
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {
                favourite.isFavourite(itemId, "btnItemAddFavourite");

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    getOwnerItems: function (ownerId, type) {

        $.mobile.changePage("#custItems", { changeHash: true });
        if (type === "owner") {
            $("#lblCustItemsHeader").text(res.ownerItems)
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemsByOwner?ownerId=" + ownerId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $("#dvCustItems").html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                IsSpecial: jsonArray[i].IsSpecial,
                                Prev: type
                            });
                        }

                        $("#dvCustItems").html("");
                        var template = Handlebars.compile($("#tmpl_items").html());
                        $("#dvCustItems").html(template(jsonItems));
                        $("#dvCustItems").trigger('create');
                    }
                    else {
                        $("#dvCustItems").html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });

    }

}

var userItems = {

    localize: function () {
        $("#lblUserItemsHeader").text(res.userItems);

        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvUserItemGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvUserItemGrp").addClass("ui-btn-left");
        }

    },

    load: function (getMoney) {

        $dvUSerItems = $("#dvUserItems");
        if (getMoney) {
            $dvUSerItems = $("#dvUserSwap");
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemsByOwner?ownerId=" + localStorage.getItem("Swap_UserId") + "&getMoney=" + getMoney,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvUSerItems.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };
                        var type = "user";
                        if (getMoney) {
                            type = "swap";
                        }

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                IsSpecial: jsonArray[i].IsSpecial,
                                type: type
                            });
                        }

                        $dvUSerItems.html("");
                        var template = Handlebars.compile($("#tmpl_items").html());
                        $dvUSerItems.html(template(jsonItems));
                        $dvUSerItems.trigger('create');
                    }
                    else {
                        $dvUSerItems.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    openItem: function (itemId) {

        $("#btnDeleteItem").text(res.delete);

        // prepare imgs container
        $reslide = $("#ulUserSlides");
        $reslide.html("");
        $reslide.html("<li><img id='imgUserItemView' src='' /></li>")

        $image = $("#imgUserItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    $.mobile.changePage("#userItems", { changeHash: true });
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblUserItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvUserItemViewDec").text(jsonArray[0].Description);
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    deleteItem: function () {
        if (confirm(res.confirmItemDel)) {

            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/DeleteItem?itemId=" + $("#hdnItemId").val(),
                success: function (result) {
                    if (result === "Error") {
                        alert(res.errDeleteItem);
                    }
                    else {
                        $.mobile.changePage("#userItems", { changeHash: true });
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });

        }
    }

}

var ownerItems = {

    localize: function () {
        $("#lblOwnerItemsHeader").text(res.ownerItems);
    },

    load: function () {

        $dvOwnerItems = $("#dvOwnerItems");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemsByOwner?ownerId=" + window.global.ownerId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvOwnerItems.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                IsSpecial: jsonArray[i].IsSpecial,
                                type: "owner"
                            });
                        }

                        $dvOwnerItems.html("");
                        var template = Handlebars.compile($("#tmpl_items").html());
                        $dvOwnerItems.html(template(jsonItems));
                        $dvOwnerItems.trigger('create');
                    }
                    else {
                        $dvOwnerItems.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    openItem: function (itemId) {
        $("#btnOwnerSwap").text(res.swap);

        // prepare imgs container
        $reslide = $("#ulOwnerSlides");
        $reslide.html("");
        $reslide.html("<li><img id='imgOwnerItemView' src='' /></li>")

        $image = $("#imgOwnerItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    $.mobile.changePage("#ownerItems", { changeHash: true });
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblOwnerItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvOwnerItemViewDec").text(jsonArray[0].Description);
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {

                favourite.isFavourite(itemId, "btnOwnerAddFavourite");

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    itemViewLoad: function () {
        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvOwnerItemViewGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvOwnerItemViewGrp").addClass("ui-btn-left");
        }
    }
}

var myAccount = {

    localize: function () {
        $("#txtLoginMail").attr("placeholder", res.email);
        $("#txtLoginPassword").attr("placeholder", res.password);
        $("#btnLogin").text(res.login);
        $("#btnRegister").text(res.register);
        $("#btnForgetPwd").text(res.forgetPwd);
    },

    load: function () {
        if (localStorage.getItem("Swap_UserId") !== null) {
            $("#dvLogin").hide();
            $("#dvMyAccount").show();
            $("#lblMyAccountHeader").text(res.myAccount);
        }
        else {
            $("#dvLogin").show();
            $("#dvMyAccount").hide();
            $("#lblMyAccountHeader").text(res.login)
        }
    },

    login: function () {

        $email = $("#txtLoginMail");
        $password = $("#txtLoginPassword");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/LoginUser?email=" + $email.val() + "&password=" + $password.val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLogin);
                }
                else {
                    if (parseInt(result) > 0) {
                        $email.val("");
                        $password.val("");
                        localStorage.setItem("Swap_UserId", result);
                        if (window.global.prevPage !== "") {
                            app.onBackButton();
                        }
                        else {
                            myAccount.load();
                        }
                    }
                    else {
                        alert(res.invalidLogin);
                    }

                }
            },
            complete: function () {
                notifications.initialize();
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });

    },

    validateLogin: function () {

        var result = true;

        $email = $("#txtLoginMail");
        $password = $("#txtLoginPassword");

        // email
        if ($email.val() === "") {
            $email.addClass("validation");
            result = false;
        }
        else {
            $email.removeClass("validation");
        }

        // password
        if ($password.val() === "") {
            $password.addClass("validation");
            result = false;
        }
        else {
            $password.removeClass("validation");
        }

        return result;
    }
}

var register = {

    localize: function () {
        $("#txtRegName").attr("placeholder", res.name);
        $("#ddlCountery").attr("placeholder", res.country);
        $("#txtRegPhone").attr("placeholder", res.phone);
        $("#txtRegMail").attr("placeholder", res.email);
        if (localStorage.getItem("Swap_UserId") === null) {
            $("#txtRegPwd").attr("placeholder", res.password);
            $("#txtRegPwdConfim").attr("placeholder", res.passwordConfirm);
            $("#btnSubmitRegister").text(res.register);
        }
        else {
            $("#txtRegPwd").attr("placeholder", res.oldPassword);
            $("#txtRegPwdConfim").attr("placeholder", res.newPassword);
            $("#btnSubmitRegister").text(res.save);
        }
    },

    load: function () {

        $ddlCountry = $("#ddlCountery");
        $ddlCountry.html("");
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetCountriesByLang?lang=" + localStorage.getItem("Swap_lang"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    jsonArray = $.parseJSON(result);
                    var lst = "";
                    for (i = 0; i < jsonArray.length; i++) {
                        lst += "<option value='" + jsonArray[i].CountryId + "'>" + jsonArray[i].CountryName + "</option>";
                    }

                    $ddlCountry.html(lst);
                    $ddlCountry.selectmenu('refresh', true);
                    $("#ddlCountery option:first").attr("selected", "selected");
                }
            },
            complete: function () {
                if (localStorage.getItem("Swap_UserId") !== null) {
                    register.getUserInfo();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    validate: function () {
        var result = true;

        $name = $("#txtRegName");
        $country = $("#ddlCountery");
        $phone = $("#txtRegPhone");
        $mail = $("#txtRegMail");
        $password = $("#txtRegPwd");
        $rePassword = $("#txtRegPwdConfim");

        // name
        if ($name.val() === "") {
            $name.addClass("validation");
            result = false;
        }
        else {
            $name.removeClass("validation");
        }

        // country
        if (parseInt($country.val()) === 0) {
            $("#ddlCountery-button").addClass("validation");
            result = false;

        }
        else {
            $("#ddlCountery-button").removeClass("validation");
        }

        // phone
        if ($phone.val() === "") {
            $phone.addClass("validation");
            result = false;
        }
        else {
            $phone.removeClass("validation");
        }

        // email
        if ($mail.val() !== "") {
            var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
            if (testEmail.test($mail.val())) {
                $mail.removeClass("validation");
            }
            else {
                $mail.addClass("validation");
                result = false;
            }
        }
        else {
            $mail.addClass("validation");
            result = false;
        }

        if (localStorage.getItem("Swap_UserId") === null) {

            // password
            if ($password.val() === "") {
                $password.addClass("validation");
                result = false;
            }
            else {
                $password.removeClass("validation");
            }

            // re-password
            if ($rePassword.val() === "") {
                $rePassword.addClass("validation");
                result = false;
            }
            else {
                $rePassword.removeClass("validation");
            }

            // password match
            if ($password.val() !== "" && $rePassword.val() !== "") {
                if ($password.val() != $rePassword.val()) {
                    $password.addClass("validation");
                    $rePassword.addClass("validation");
                    result = false;
                }
                else {
                    $password.removeClass("validation");
                    $rePassword.removeClass("validation");
                }
            }
        }

        return result;
    },

    register: function () {
        var arrUser = [];
        arrUser.push({
            UserName: $("#txtRegName").val(),
            CountryId: $("#ddlCountery").val(),
            Phone: $("#txtRegPhone").val(),
            Email: $("#txtRegMail").val(),
            Password: $("#txtRegPwd").val(),
            Uuid: device.uuid
        });
        jsonUser = JSON.stringify(arrUser);

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/AddUSer?jsonUser=" + jsonUser,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errRegister);
                }
                else if (result === "EmailExist") {
                    alert(res.mailExist);
                }
                else if (result === "MobileExist") {
                    alert(res.mobileExist);
                }
                else {
                    localStorage.setItem("Swap_UserId", result);
                    register.clear();
                    $.mobile.changePage("#myAccount", { changeHash: true });
                }
            },
            complete: function () {
                notifications.initialize();
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    clear: function () {
        $("#txtRegName").val("");
        $("#ddlCountery").val("0");
        $("#txtRegPhone").val("");
        $("#txtRegMail").val("");
        $("#txtRegPwd").val("");
        $("#txtRegPwdConfim").val("");
    },

    getUserInfo: function () {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetUserById?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    jsonArray = $.parseJSON(result);
                    $("#txtRegName").val(jsonArray[0].UserName);
                    $("#ddlCountery").val(jsonArray[0].CountryId);
                    $("#txtRegPhone").val(jsonArray[0].Phone);
                    $("#txtRegMail").val(jsonArray[0].Email);

                    $ddlCountry.selectmenu('refresh', true);
                }
            },
            error: function (result) {
                alert(res.checkConnection);
                return;
            }
        });
    },

    update: function () {
        var arrUser = [];
        arrUser.push({
            UserId: localStorage.getItem("Swap_UserId"),
            UserName: $("#txtRegName").val(),
            CountryId: $("#ddlCountery").val(),
            Phone: $("#txtRegPhone").val(),
            Email: $("#txtRegMail").val(),
            Password: $("#txtRegPwd").val(),
            NewPassword: $("#txtRegPwdConfim").val(),
        });
        jsonUser = JSON.stringify(arrUser);

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/UpdateUser?jsonUser=" + jsonUser,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errRegister);
                }
                else if (result === "EmailExist") {
                    alert(res.mailExist);
                }
                else if (result === "MobileExist") {
                    alert(res.mobileExist);
                }
                else if (result === "InvalidPassword") {
                    alert(res.invalidPassword);
                }
                else {
                    register.clear();
                    $.mobile.changePage("#myAccount", { changeHash: true });
                }
            },
            complete: function () {
                notifications.initialize();
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }

}

var resetPwd = {

    localize: function () {
        $("#lblResetPwdHeader").text(res.resetPwd);
        $("#txtResetMail").attr("placeholder", res.email);
        $("#btnResetPwd").text(res.sendPwd);
    },

    reset: function () {

        $email = $("#txtResetMail");
        if ($email.val() === "") {
            $email.addClass("validation");
            return;
        }
        else {
            $email.removeClass("validation");
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/ResetPassword?email=" + $email.val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.resetErr);
                }
                else if (result === "UserNotFound") {
                    alert(res.invalidUser);
                }
                else if (result === "success") {
                    alert(res.resetSuccess);
                    $.mobile.changePage("#myAccount", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection);
                return;
            }
        });


    }

}

var custItems = {

    load: function () {
        if (window.global.prevPage === "user") {

        }
    }
}

var addItem = {

    localize: function () {
        $("#lblAddItemHeader").text(res.addItem);
        $("#txtAddItem").attr("placeholder", res.itemName);
        $("#txtItemDesc").attr("placeholder", res.itemDesc);
        $("#btnAdditemImg").text(res.addImg);
        $("#btnSaveItem").text(res.saveItem);
        $("#btnAddSpecial").text(res.addSpecial);
    },

    load: function () {

        // to prevent reloading and clearing section drop down list
        if ($("#hdnSelectedSection").val() !== "") {
            return;
        }

        $ddlSection = $("#ddlSection");
        $ddlSection.html("");
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetSectionListed?lang=" + localStorage.getItem("Swap_lang"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    jsonArray = $.parseJSON(result);
                    var lst = "";
                    for (i = 0; i < jsonArray.length; i++) {
                        lst += "<option value='" + jsonArray[i].SectionId + "'>" + jsonArray[i].SectionName + "</option>";
                    }

                    $ddlSection.html(lst);
                    $ddlSection.selectmenu('refresh', true);
                    $("#ddlSection option:first").attr("selected", "selected");
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });

    },

    validate: function () {

        var result = true;
        $ddlSection = $("#ddlSection");
        $txtAddItem = $("#txtAddItem");
        $txtItemDesc = $("#txtItemDesc");
        $img = $("#imgPreview");

        // section
        if (parseInt($ddlSection.val()) === 0) {
            $("#ddlSection-button").addClass("validation");
            result = false;
        }
        else {
            $("#ddlSection-button").removeClass("validation");
        }

        // itemName
        if ($txtAddItem.val() === "") {
            $txtAddItem.addClass("validation");
            result = false;
        }
        else {
            $txtAddItem.removeClass("validation");
        }

        // item description
        if ($txtItemDesc.val() === "") {
            $txtItemDesc.addClass("validation");
            result = false;
        }
        else {
            $txtItemDesc.removeClass("validation");
        }

        // image
        if ($img.attr("src") === "") {
            alert(res.imgreq);
            result = false;
        }

        return result;

    },

    add: function (imgName) {

        var img = document.getElementById('imgPreview');

        var arrItem = [];
        arrItem.push({
            SectionId: $("#ddlSection").val(),
            OwnerId: localStorage.getItem("Swap_UserId"),
            ItemName: $("#txtAddItem").val(),
            Description: $("#txtItemDesc").val(),
            MainPicture: imgName,
            IsSpecial: window.global.isSpecial
        });
        jsonUser = JSON.stringify(arrItem);

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/AddItem?jsonItem=" + jsonUser,
            success: function (result) {
                if (!isNaN(result)) {
                    $("#hdnAddedItemId").val(result);

                    if (window.global.isSpecial === true) {
                        $.mobile.changePage("#addSpecial", { changeHash: true });
                    }
                    else {
                        $.mobile.changePage("#userItems", { changeHash: true });
                    }

                    addItem.clear();
                }
                else {
                    alert(res.addItemErr);
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });

    },

    clear: function () {

        $("#ddlSection").val("0");
        $("#txtAddItem").val("");
        $("#txtItemDesc").val("");
        $("#imgPreview").attr("src", "");
        $("#imgPreview").css("display", "none");
        $("#hdnSelectedSection").val("");
    },

    addPicture: function (picture) {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/AddItemPicture?itemId=" + $("#hdnAddedItemId").val() + "&picture=" + picture,
            success: function (result) {
                if (result == "Error") {

                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }

}

var addSpecial = {

    localize: function () {
        $("#lblAddSpecialHeader").text(res.addSpecial);
        $("#btnSaveSpecial").text(res.save);
    }

}

var camera = {

    success: function (uri) {
        var img = document.getElementById('imgPreview');
        img.style.visibility = "visible";
        img.style.display = "";
        img.style.width = "50%";
        img.style.height = "50%";
        img.src = uri;

        $(".ui-dialog").dialog("close");
    },

    success1: function (uri) {
        var img = document.getElementById('imgPreview1');
        img.src = uri;
        $(".ui-dialog").dialog("close");
    },

    success2: function (uri) {
        var img = document.getElementById('imgPreview2');
        img.src = uri;
        $(".ui-dialog").dialog("close");
    },

    success3: function (uri) {
        var img = document.getElementById('imgPreview3');
        img.src = uri;
        $(".ui-dialog").dialog("close");
    },

    fail: function () {
        //alert(res.cameraErr);
    },

    upload: function (fromSpecial, src) {
        // Get URI of picture to upload
        var img;

        if (src === "main") {
            img = document.getElementById('imgPreview');
        }
        else if (src === "special1") {
            img = document.getElementById('imgPreview1');
        }
        else if (src === "special2") {
            img = document.getElementById('imgPreview2');
        }
        else if (src === "special3") {
            img = document.getElementById('imgPreview3');
        }

        var imageURI = img.src;

        var ft = new FileTransfer();
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.fileName = imageURI.substr(imageURI.lastIndexOf('/') + 1);
        options.mimeType = "image/jpeg";
        options.chunkedMode = false;

        // Transfer picture to server

        $.mobile.loading('show');
        ft.upload(imageURI, "http://213.34.206.43/swap.webdesk/data/UploadItemImage", function (r) {
            $.each(r, function (key, value) {
                if (key == "response") {
                    $.mobile.loading('hide');
                    var obj = $.parseJSON(value);
                    if (fromSpecial === false) {
                        addItem.add(obj.fileName);
                    }
                    else {
                        addItem.addPicture(obj.fileName);
                    }
                }
            });
        }, function (error) {
            $.mobile.loading('hide');
            alert(error);
            switch (error.code) {
                case FileTransferError.FILE_NOT_FOUND_ERR:
                    // alert(res.tryAgain);
                    break;

                case FileTransferError.INVALID_URL_ERR:
                    alert("Bad Photo URL");
                    break;

                case FileTransferError.CONNECTION_ERR:
                    alert(res.imgConnectionErr);
                    break;

                default:
                    alert(res.uploadErr);
                    break;
            }
        }, options);


    }

}

var contactUs = {

    localize: function () {
        $("#lblcontactUsHeader").val(res.contactUs);
        $("#txtContactName").attr("placeholder", res.name);
        $("#txtContactMail").attr("placeholder", res.email);
        $("#txtContactMsg").attr("placeholder", res.writeMsg);
        $("#btnContactSend").text(res.send);
    },

    validate: function () {
        var result = true;
        $name = $("#txtContactName");
        $mail = $("#txtContactMail");
        $msg = $("#txtContactMsg");

        // name
        if ($name.val() === "") {
            $name.addClass("validation");
            result = false;
        }
        else {
            $name.removeClass("validation");
        }

        // email
        if ($mail.val() !== "") {
            var testEmail = /^[A-Z0-9._%+-]+@([A-Z0-9-]+\.)+[A-Z]{2,4}$/i;
            if (testEmail.test($mail.val())) {
                $mail.removeClass("validation");
            }
            else {
                $mail.addClass("validation");
                result = false;
            }
        }
        else {
            $mail.addClass("validation");
            result = false;
        }

        // message
        if ($msg.val() === "") {
            $msg.addClass("validation");
            result = false;
        }
        else {
            $msg.removeClass("validation");
        }

        return result;
    },

    send: function () {

        $name = $("#txtContactName");
        $mail = $("#txtContactMail");
        $msg = $("#txtContactMsg");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/AddContactMessage?name=" + $name.val() + "&email=" + $mail.val() + "&message=" + $msg.val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errSend);
                }
                else {

                    $name.val("");
                    $mail.val("");
                    $msg.val("");
                    $message = $("#message");
                    $message.css('background-repeat', 'no-repeat');
                    $message.css('background-size', '100% auto');
                    $message.css('background-position', 'center');
                    if (localStorage.getItem("Swap_lang") === "ar") {
                        $message.css('background-image', 'url("images/smile_thanks_ar.png")');
                    }
                    else {
                        $message.css('background-image', 'url("images/smile_thanks_en.png")');
                    }
                    $.mobile.changePage("#message", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }

}

var message = {

    load: function () {
        setTimeout(function () { $.mobile.changePage("#home", { changeHash: true }); }, 1500);
    }

}

var swap = {

    localize: function () {
        $("#btnSwapIt").text(res.swapIt);
        $("#btnSaveSwap").text(res.swapIt);
        $("#btnCancelSwapDlg").text(res.cancel);
        $("#txtSwapComment").attr("placeholder", res.comment);
    },

    goSwap: function () {
        $.mobile.changePage("#userSwap", { changeHash: true });
    },

    select: function (itemId) {
        $item = $("#" + itemId);

        if ($item.hasClass("cls_selected")) {
            $item.removeClass("cls_selected");

            var index = 0;
            for (var i = 0; i < swapItems.length; i++) {
                if (swapItems[i] == itemId) {
                    index = i;
                }
            }

            swapItems.splice(index, 1)


        }
        else {
            $item.addClass("cls_selected");
            swapItems.push(itemId);
        }
    },

    doSwap: function () {
        if (swapItems.length === 0) {
            alert(res.noItems);
            return;
        }

        var offerItems = JSON.stringify(swapItems);

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/AddTransaction?dealerId=" + localStorage.getItem("Swap_UserId") + "&itemId=" + $("#hdnItemId").val() + "&offerItems=" + offerItems + "&comment=" + $("#txtSwapComment").val(),
            success: function (result) {
                if (result == "success") {
                    $("#txtSwapComment").val("");
                    swapItems = [];
                    $message = $("#message");
                    $message.css('background-repeat', 'no-repeat');
                    $message.css('background-size', '60% auto');
                    $message.css('background-position', 'center');
                    if (localStorage.getItem("Swap_lang") === "ar") {
                        $message.css('background-image', 'url("images/thanks_message_ar.png")');
                    }
                    else {
                        $message.css('background-image', 'url("images/thanks_message_en.png")');
                    }
                    $.mobile.changePage("#message", { changeHash: true });
                }
                else if (result === "DealerIsOwner") {
                    alert(res.swapUsersErr);
                }
                else if (result === "Error") {
                    alert(res.errSwap);
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

}

var search = {

    localize: function () {
        $("#lblSearchHeader").text(res.search);
        $("#txtSearch").attr("placeholder", res.srchPlaceHolder);
        $("#btnSearch").text(res.search);
    },

    load: function () {
        $ddlSection = $("#ddlSearchSection");
        $ddlSection.html("");
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetSectionListed?lang=" + localStorage.getItem("Swap_lang"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    jsonArray = $.parseJSON(result);
                    var lst = "";
                    for (i = 0; i < jsonArray.length; i++) {
                        lst += "<option value='" + jsonArray[i].SectionId + "'>" + jsonArray[i].SectionName + "</option>";
                    }

                    $ddlSection.html(lst);
                    $ddlSection.selectmenu('refresh', true);
                    $("#ddlSection option:first").attr("selected", "selected");
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    search: function () {
        $dvSearchViewContent = $("#dvSearchViewContent");
        var userId = 0;
        if (localStorage.getItem("Swap_UserId") !== null) {
            userId = localStorage.getItem("Swap_UserId");
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/SearchItems?strSearch=" + $("#txtSearch").val() + "&sectionId=" + $("#ddlSearchSection").val() + "&onlySpecial=false&userId=" + userId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvSearchViewContent.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                type: "search"
                            });
                        }

                        $dvSearchViewContent.html("");
                        var template = Handlebars.compile($("#tmpl_HomeItems").html());
                        $dvSearchViewContent.html(template(jsonItems));
                        $dvSearchViewContent.trigger('create');

                        $("#lblSearchItemsHeader").text(res.searchResult)
                        $.mobile.changePage("#searchItems", { changeHash: true });
                    }
                    else {
                        $dvSearchViewContent.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    openItem: function (itemId) {

        $("#btnSearchItemSwap").text(res.swap);
        $("#btnSearchOwnerItems").text(res.ownerItems);

        // prepare imgs container
        $reslide = $("#ulSearchItemView");
        $reslide.html("");
        $reslide.html("<li><img id='imgSearchItemView' src='' /></li>")

        $image = $("#imgSearchItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    history.go(-1);
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblSearchItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvSearchItemViewDec").text(jsonArray[0].Description);
                    window.global.ownerId = jsonArray[0].OwnerId;
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {

                favourite.isFavourite(itemId, "btnSrchAddFavourite");

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    itemViewLoad: function () {
        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvSrchItemViewGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvSrchItemViewGrp").addClass("ui-btn-left");
        }
    }

}

var pendingSwap = {

    load: function () {

        $("#lblPendingSwapHeader").text(res.pendingSwap);
        $dvPendingSwap = $("#dvPendingSwap");
        $dvPendingSwap.html("");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetActiveTransactions?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvPendingSwap.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonTrans = { transaction: [] };

                        for (i = 0; i < jsonArray.length; i++) {

                            var modeType = "";
                            var GivePending = false;
                            var TakePending = false;
                            var Accepted = false;
                            var tranStatusId = jsonArray[i].TransactionStatusId;
                            var tranType = jsonArray[i].TransactionType;


                            if (tranStatusId == window.global.TranStatusPending && tranType == "Give") {
                                GivePending = true;
                                modeType = "GivePending";
                            }
                            else if (tranStatusId == window.global.TranStatusPending && tranType == "Take") {
                                TakePending = true;
                                modeType = "TakePending";
                            }
                            else if (tranStatusId == window.global.TranStatusAccepted) {
                                Accepted = true;
                                modeType = "Accepted";
                            }


                            jsonTrans.transaction.push({
                                TransactionId: jsonArray[i].TransactionId,
                                DealerOfferImg: jsonArray[i].DealerOfferImg,
                                TransactionType: jsonArray[i].TransactionType,
                                TransactionStatusId: jsonArray[i].TransactionStatusId,
                                ClientItemImg: jsonArray[i].ClientItemImg,
                                GivePending: GivePending,
                                TakePending: TakePending,
                                Accepted: Accepted,
                                TranType: tranType,
                                ModeType: modeType,
                                ResCancel: res.cancel,
                                ResAccept: res.accept,
                                ResReject: res.reject,
                                ResCall: res.call
                            });
                        }

                        $dvPendingSwap.html("");
                        var template = Handlebars.compile($("#tmpl_pendingSwap").html());
                        $dvPendingSwap.html(template(jsonTrans));
                        $dvPendingSwap.trigger('create');
                    }
                    else {
                        $dvPendingSwap.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    cancel: function (transactionId) {
        if (confirm(res.confirmCancel)) {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/CancelTransaction?transactionId=" + transactionId,
                success: function (result) {
                    if (result === "Error") {
                        alert(res.errCancel);
                    }
                    else {
                        pendingSwap.load();
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });
        }
    },

    reject: function (transactionId) {
        if (confirm(res.confirmReject)) {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/RejectTransaction?transactionId=" + transactionId,
                success: function (result) {
                    if (result === "Error") {
                        alert(res.errCancel);
                    }
                    else {
                        pendingSwap.load();
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });
        }
    },

    accept: function (transactionId) {
        if (confirm(res.confirmAccept)) {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/AcceptTransaction?transactionId=" + transactionId,
                success: function (result) {
                    if (result === "Error") {
                        alert(res.errCancel);
                    }
                    else {
                        pendingSwap.load();
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });
        }
    },

    call: function (transactionId) {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetTransactionUser?transactionId=" + transactionId + "&loggedUserId=" + localStorage.getItem("Swap_UserId") + "&lang=" + localStorage.getItem("Swap_lang"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    jsonArray = $.parseJSON(result);
                    $("#lblName").text(res.lblName);
                    $("#txtCallName").text(jsonArray[0].UserName);
                    $("#lblCountry").text(res.lblCountry);
                    $("#txtCallCountry").text(jsonArray[0].CountryName);
                    $("#lblEmail").text(res.lblEmail);
                    $("#txtCallEmail").text(jsonArray[0].Email);
                    $("#lblPhone").text(res.lblPhone);
                    $("#txtCallPhone").text(jsonArray[0].Phone);
                    $("#btnCloseCall").text(res.close);
                }
            },
            complete: function () {
                $("#btnDlgCall").click();
                // $.mobile.changePage("#dlgCall", { changeHash: true });
            },
            error: function (result) {
                alert(res.checkConnection);
                return;
            }
        });
    },

    makeCall: function () {
        window.open('tel:' + document.getElementById("txtCallPhone").innerHTML, '_system');
    },

    makeMail: function () {
        window.open('mailto:' + document.getElementById("txtCallEmail").innerHTML, '_system');
    },

    swapViewLocalize: function () {
        $("#lblPendingSwapViewHeader").text(res.offerDetail);
        $("#btnSwapCancel").text(res.cancel);
        $("#btnSwapAccept").text(res.accept);
        $("#btnSwapReject").text(res.reject);
        $("#btnSwapCall").text(res.call);
        $("#btnCancelSwap").text(res.swapBack);
        $("#btnSwapComplete").text(res.swapComplete);
    },

    openOffer: function (transactionId, tranType, modeType, isCompleted) {

        if (isCompleted) {
            return;
        }

        $("#hdnTransactionId").val(transactionId);
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetTransactionItem?transactionId=" + transactionId + "&tranType=" + tranType,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    pendingSwapViewArr = $.parseJSON(result);
                    $("#imgPendingSwap").attr("src", pendingSwapViewArr[pendingSwapVavIndex].ImageUrl);
                    $("#dvPendingSwapViewDesc").html(pendingSwapViewArr[pendingSwapVavIndex].Description);
                }
            },
            complete: function () {

                if (modeType === "GivePending") {
                    $("#trGivePending").css("display", "");
                    $("#trTakePending").css("display", "none");
                    $("#trAccepted").css("display", "none");
                }
                else if (modeType === "TakePending") {
                    $("#trTakePending").css("display", "");
                    $("#trGivePending").css("display", "none");
                    $("#trAccepted").css("display", "none");
                }
                else if (modeType === "Accepted") {
                    $("#trAccepted").css("display", "");
                    $("#trTakePending").css("display", "none");
                    $("#trGivePending").css("display", "none");
                }

                // to put completed button only for the owner
                pendingSwap.checkTranClient(transactionId);

                // to hide navigation buttons if dealer offer contain only one item
                if (pendingSwapViewArr.length === 1) {
                    $("#dvNavigation").hide();
                }
                else {
                    $("#dvNavigation").show();
                }

                $.mobile.changePage("#pendingSwapViwe", { changeHash: true });
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });



    },

    checkTranClient: function (transactionId) {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetTransactionClient?transactionId=" + transactionId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    if (result == localStorage.getItem("Swap_UserId")) {
                        $("#btnSwapComplete").css("display", "");
                    }
                    else {
                        $("#btnSwapComplete").css("display", "none");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    complete: function () {
        if (confirm(res.confirmComplete) === false) {
            return;
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/CompleteTransaction?transactionId=" + $("#hdnTransactionId").val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errComplete);
                }
                else {
                    $.mobile.changePage("#pendingSwap", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    Reset: function () {

        if (confirm(res.confirmReset) === false) {
            return;
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/ResetTransaction?transactionId=" + $("#hdnTransactionId").val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errComplete);
                }
                else {
                    $.mobile.changePage("#pendingSwap", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }

}

var completedSwap = {

    load: function () {
        $("#lblCompletedSwapHeader").text(res.completedSwap);
        $dvPendingSwap = $("#dvCompletedSwap");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetCompletedTransactions?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvPendingSwap.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonTrans = { transaction: [] };

                        for (i = 0; i < jsonArray.length; i++) {

                            var modeType = "";
                            var GivePending = false;
                            var TakePending = false;
                            var Accepted = false;
                            var completed = false;
                            var tranStatusId = jsonArray[i].TransactionStatusId;
                            var tranType = jsonArray[i].TransactionType;


                            if (tranStatusId == window.global.TranStatusPending && tranType == "Give") {
                                GivePending = true;
                                modeType = "GivePending";
                            }
                            else if (tranStatusId == window.global.TranStatusPending && tranType == "Take") {
                                TakePending = true;
                                modeType = "TakePending";
                            }
                            else if (tranStatusId == window.global.TranStatusAccepted) {
                                Accepted = true;
                                modeType = "Accepted";
                            }
                            else if (tranStatusId == window.global.TranStatusCompleted) {
                                completed = true;
                            }


                            jsonTrans.transaction.push({
                                TransactionId: jsonArray[i].TransactionId,
                                DealerOfferImg: jsonArray[i].DealerOfferImg,
                                TransactionType: jsonArray[i].TransactionType,
                                TransactionStatusId: jsonArray[i].TransactionStatusId,
                                ClientItemImg: jsonArray[i].ClientItemImg,
                                GivePending: GivePending,
                                TakePending: TakePending,
                                Accepted: Accepted,
                                TranType: tranType,
                                ModeType: modeType,
                                Completed: completed
                            });
                        }

                        $dvPendingSwap.html("");
                        var template = Handlebars.compile($("#tmpl_pendingSwap").html());
                        $dvPendingSwap.html(template(jsonTrans));
                        $dvPendingSwap.trigger('create');
                    }
                    else {
                        $dvPendingSwap.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }

}

var favourite = {

    isFavourite: function (itemId, button) {
        $button = $("#" + button);
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/IsItemFavourite?itemId=" + itemId + "&userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "True") {
                    $button.addClass("cls_favSelected");
                    $button.removeClass("cls_favUnSelected");
                }
                else if (result === "False") {
                    $button.addClass("cls_favUnSelected");
                    $button.removeClass("cls_favSelected");
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    toggleFavourite: function (button) {
        $button = $("#" + button);
        if ($button.hasClass("cls_favUnSelected")) {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/AddFavourite?userId=" + localStorage.getItem("Swap_UserId") + "&itemId=" + $("#hdnItemId").val(),
                success: function (result) {
                    if (result === "Error") {
                        alert(res.favErr);
                    }
                    else {
                        $button.removeClass("cls_favUnSelected");
                        $button.addClass("cls_favSelected");
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });
        }
        else {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: window.global.serviceURL + "soap/RemoveUserFavourite?userId=" + localStorage.getItem("Swap_UserId") + "&itemId=" + $("#hdnItemId").val(),
                success: function (result) {
                    if (result === "Error") {
                        alert(res.favErr);
                    }
                    else {
                        $button.removeClass("cls_favSelected");
                        $button.addClass("cls_favUnSelected");
                    }
                },
                error: function (result) {
                    alert(res.checkConnection)
                    return;
                }
            });
        }
    },

    load: function () {
        $("#lblFavouriteHeader").text(res.favourite);
        $("#btnResetFavourite").text(res.clearList);
        $dvFavourite = $("#dvFavourite");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetUserFavourtes?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {
                    $dvFavourite.html("");
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        var jsonItems = { items: [] };

                        for (i = 0; i < jsonArray.length; i++) {
                            jsonItems.items.push({
                                ItemId: jsonArray[i].ItemId,
                                ImageUrl: jsonArray[i].ImageUrl,
                                Class: jsonArray[i].Class,
                                IsSpecial: jsonArray[i].IsSpecial,
                                type: "favourite",
                            });
                        }

                        $dvFavourite.html("");
                        var template = Handlebars.compile($("#tmpl_items").html());
                        $dvFavourite.html(template(jsonItems));
                        $dvFavourite.trigger('create');
                    }
                    else {
                        $dvFavourite.html("");
                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    openItem: function (itemId) {

        $("#btnFavItemSwap").text(res.swap);
        $("#btnFavOwnerItems").text(res.ownerItems);

        // prepare imgs container
        $reslide = $("#ulFavItemView");
        $reslide.html("");
        $reslide.html("<li><img id='imgFavItemView' src='' /></li>")

        $image = $("#imgFavItemView");
        $image.removeClass("cls_special");
        $image.removeClass("cls_normal");

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetItemDetails?itemId=" + itemId,
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                    history.go(-1);
                }
                else {
                    jsonArray = $.parseJSON(result);

                    $("#lblFavItemViewHeader").text(jsonArray[0].ItemName);
                    $image.attr("src", jsonArray[0].ImageUrl);
                    $image.addClass(jsonArray[0].Class);
                    $("#dvFavItemViewDec").text(jsonArray[0].Description);
                    window.global.ownerId = jsonArray[0].OwnerId;
                    $("#hdnItemId").val(itemId);
                }
            },
            complete: function () {

                // check if item is special and load other images if any
                if ($image.hasClass("cls_special")) {
                    items.getMorePics(itemId, $reslide);
                }
                else {
                    // to hide navigation keys of slide
                    $(".callbacks_nav").hide();
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    clear: function () {
        if (confirm(res.confirmClrFav) === false) {
            return;
        }

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/ClearUserFavourte?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.favClearErr);
                }
                else {
                    $.mobile.changePage("#myAccount", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    remove: function () {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/RemoveUserFavourite?userId=" + localStorage.getItem("Swap_UserId") + "&itemId=" + $("#hdnItemId").val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.favErr);
                }
                else {
                    $.mobile.changePage("#favourite", { changeHash: true });
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    itemViewLoad: function () {
        if (localStorage.getItem("Swap_lang") === "en") {
            $("#dvFavouriteItemViewGrp").addClass("ui-btn-right");
        }
        else {
            $("#dvFavouriteItemViewGrp").addClass("ui-btn-left");
        }
    }

}

var setting = {

    localize: function () {
        $("#btnAboutUs").text(res.aboutUs);
        $("#btnSpecialAdvantage").text(res.specialAdvantage);
        $("#btnContactUs").text(res.contactUs);
        $("#lblSettingHeader").text(res.setting);
        $("#lblNotification").text(res.lblNotifications);
        $("#lblNotificationOn").text(res.on);
        $("#lblNotificationOff").text(res.off);
    },

    load: function () {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetNotifyStatus?userId=" + localStorage.getItem("Swap_UserId"),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else {
                    $("#chkNotification").val(result).flipswitch('refresh');
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    change: function () {
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/ChangeNotifyStatus?userId=" + localStorage.getItem("Swap_UserId") + "&notifyStatus=" + $("#chkNotification").val(),
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    }
}

var aboutUs = {
    localize: function () {
        $("#lblAboutHeader").text(res.aboutUs);
        $("#spnAboutUs").text(res.aboutContent);
    }
}

var specialAdvantage = {
    localize: function () {
        $("#lblspecialAdvantagetHeader").text(res.specialAdvantage);
        $("#spnAdvancedAdvantage").text(res.specialAdvantageContent);
    }
}

var ads = {
    load: function () {
        $("#lblAdsHeader").text(res.ads);

        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetAds",
            success: function (result) {
                if (result === "Error") {
                    alert(res.errLoad);
                }
                else if (result === "Empty") {

                }
                else {

                    $reslide = $("#ulOfferView");
                    $reslide.html("");

                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {

                        var pics = "";
                        for (i = 0; i < jsonArray.length; i++) {
                            pics += "<li><img src=" + jsonArray[i].ItemPic + " /></li>";
                        }



                        $reslide.append(pics);

                        $reslide.responsiveSlides({
                            auto: true,
                            pager: false,
                            nav: true,
                            speed: 1000,
                            namespace: "callbacks",
                        });

                    }
                    else {

                    }
                }
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });

    }
}

var notifications = {

    initialize: function () {
        pushNotification = window.plugins.pushNotification;
        if (device.platform == 'android' || device.platform == 'Android') {
            window.global.appType = 1;
            pushNotification.register(
                successHandler,
                errorHandler, {
                    "senderID": window.global.senderId,
                    "ecb": "onNotificationGCM"
                });
        }
            // iphone
        else {
            pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, 1);
            window.global.appType = 2;
            pushNotification.register(
                tokenHandler,
                errorHandler, {
                    "badge": "true",
                    "sound": "true",
                    "alert": "true",
                    "ecb": "onNotificationAPN"
                });
        }
    },

    saveRegisterationId: function (regId) {

        var uuid = device.uuid;
        $.ajax({
            type: 'GET',
            dataType: "json",
            url: window.global.serviceURL + 'soap/SaveNotificationsData?userId=' + localStorage.getItem("Swap_UserId") + '&regId=' + regId + '&uuid=' + uuid + '&appType=' + window.global.appType,
            success: function (result) {
            },
            error: function (msg) {
                // error();
            }
        });
    },

    load: function () {
        $("#lblNotificationHeader").text(res.notifications);
        var jsonNotifications = { notification: [] };
        $.ajax({
            type: "GET",
            dataType: "json",
            url: window.global.serviceURL + "soap/GetNotifications",
            success: function (result) {
                if (result == "Error") {
                    alert(res.errLoad);
                }
                else if (result == "Empty") {
                    $("#dvNotifications").html('<div style="width:100%;text-align:center>No data to display</div>');
                }
                else {
                    jsonArray = $.parseJSON(result);
                    if (jsonArray.length > 0) {
                        for (i = 0; i < jsonArray.length; i++) {
                            jsonNotifications.notification.push({
                                NotificationId: jsonArray[i].NotificationId,
                                Picture: jsonArray[i].Picture,
                                Title: jsonArray[i].Title,
                                Content: jsonArray[i].Content,
                                CreatedOn:jsonArray[i].CreatedOn
                            });
                        }
                    }
                    else {
                        $("#dvNotifications").html('<div style="width:100%;text-align:center>No data to display</div>');
                    }
                }
            },
            complete: function () {
                $("#dvNotifications").html("");
                var template = Handlebars.compile($("#tmpl_Notifications").html());
                $("#dvNotifications").html(template(jsonNotifications));
                $("#dvNotifications").trigger('create');
            },
            error: function (result) {
                alert(res.checkConnection)
                return;
            }
        });
    },

    open: function (notificationId) {
        $("#lblNotificationViewHeader").text(res.notifications)
        $.mobile.changePage("#notificationView", { changeHash: true });
        $("#imgNotificationView").attr("src", $("#imgNotification" + notificationId).attr("src"));
        $("#spnNotificationTitle").text($("#spnTitle" + notificationId).text());
        $("#spnNotificationContent").text($("#spnContent" + notificationId).text());
    }

}

//#region Push Notifications
//on sucess
function successHandler(result) {
    // alert('result = ' + result);
}
//on erroe
function errorHandler(error) {
    alert('error = ' + error);
}
//on calling the GCM
function onNotificationGCM(e) {
    switch (e.event) {

        case 'registered':

            if (e.regid.length > 0) {
                //alert(e.regid);
                notifications.saveRegisterationId(e.regid)
            }
            break;

        case 'message':

            $.mobile.changePage("#notifications", { changeHash: true });

            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.
            if (e.foreground) {
                $("#app-status-ul").append('<li>--INLINE NOTIFICATION--' + '</li>');
            }
            else {  // otherwise we were launched because the user touched a notification in the notification tray.
                if (e.coldstart) {
                    $("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
                }
                else {
                    $("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
                }
            }

            break;

        case 'error':
            $("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
            break;

        default:
            $("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
            break;
    }
}
//on unregsitr
function unregister() {
    pushNotification.unregister(successHandler, errorHandler);
}
//Save the registraion id in to our data base to send notfications later

// used in iphone only

function tokenHandler(result) {
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
    alert('device token = ' + result);

    //  save device token to database
    saveRegisterationId(result)
}

// iOS
function onNotificationAPN(event) {
    if (event.alert) {
        navigator.notification.alert(event.alert);
    }

    if (event.sound) {
        var snd = new Media(event.sound);
        snd.play();
    }

    if (event.badge) {
        pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, event.badge);
    }
}

//#endregion


// variables used
// localStorage : {Swap_lang, Swap_UserId}
// hiddenFields : { hdnItemId, hdnIsSpecial, hdnOwnerSrc, hdnTransactionId, hdnAddedItemId}
